C  PROGRAMME AGNOSTC                                                            
C ***  VERSION  FORTRAN 77 - MICRO_VAX
C ***   CALCUL  DES  VECTEURS  POUR  CORRECTION  D EXTINCTION  CONFORME         
C ***   LINEX 74  : E(I),I=1,3 POUR  XN(I),I=1,3  E(I),I=4,6 POUR SODU(I        
C ***   VERSION ADAPTEE A UN DIFFRACTOMETRE PHILIPS  P W 1100 :                 
C ***   OMEGA( AGNOSTC) = THETA - OMEGA (PW1100 )                               
C ***   MATRICE D ORIENTATION ( PW1100 ) INCORPORE LAMBDA                       
C ***   DEC. 76  INCORPORATION DU TEST DES MULTIPLES  REFLECTIONS D APRE        
C ***   PROGRAMME MULREF ( P.  COPPENS )                                        
C                                                                               
C.... J. A. IBERS 312 492-5449 VERSION OF JANUARY,1974 .................        
C                                                                               
C.... DATA OBTAINED AUTOMATICALLY BY DIGITAL STEP SCAN AS WELL AS MANUAL        
C.... WRITTEN BY PHILIP COPPENS,LESLIE LEISEROWITZ AND DUBBY RABINOVICH,        
C.... WEIZMANN INSTITUTE OF SCIENCE,REHOVOTH,ISRAEL.  MODIFIED BY W.C.HA        
C THIS VERSION IS NOW CORRECT FOR OMEGA NON ZERO AS OF 14 OCT 72                
C THE COORDINATE SYSTEM USED IS AS FOLLOWS. THE LABORATORY SYSTEM               
C HAS Y ALONG THE DIFFRACTION VECTOR, X POINTING IN THE DIRECTION               
C OF THE INCOMING BEAM, AND Z COMPLETES THE RIGHT-HANDED COORDINATE             
C SYSTEM ( SO THAT Z POINTS TOWARD THE CEILING).                                
C THE SENSES OF ROTATION OF OUR ANGLES AT THE ZERO OF ALL ANGLES ARE            
C  THETA   Y GOES INTO X FOR + ROTATION. CHI   Y GOES INTO Z FOR                
C + ROTATION. OMEGA   Y GOES INTO X FOR + ROTATION. PHI X GOES INTO Y           
C FOR + ROTATION.   IT WILL BE OBSERVED THAT THESE ARE THE SENSES OF A          
C FACS1 MACHINE WORKING IN THE UPPER HEMISPHERE WHERE THE 0 OF CHI              
C HANGS THE CRYSTAL UPSIDE DOWN ( AND HENCE Z POINTS FROM CRYSTAL TO            
C GONIOMETER HEAD BASE).  THE VARIOUS EQUATIONS INOLVED IN SUBROUTINE           
C DIRCOS FOLLOW DIRECTLY FROM THESE DEFINITIONS AND FROM HAMILTONS              
C ARTICLE IN INTERNATIONAL TABLES VOLUME 4.                                     
C                                                                               
      CHARACTER *6 ENTRPL,SORTPL,EXITPL                                         
      REAL*8 ABS,ABS1,ABS2,VOL,VOLUME 
      REAL*8 GRID(4,4000)                                                       
      INTEGER TIT(20)                                                           
      COMMON EPOA,EPOB,GRID                                                     
      COMMON /A/ RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)        
     $,WI                                                                       
      COMMON/C/DATA(25,4)                                                       
      COMMON/D/ELAMDA,COST,SINT,EMU,NPOINT,TETA                                 
      COMMON/E/ABS,VOLUME,NFACES                                                
      COMMON/BORR/SN(25),NMAX,ABSO                                              
      COMMON/REFL/X(3),SCALEN,FSQD,SIGSQ,CHI,CINT,GCOR,NREF,TOTET,OM,PHI        
     $,IDENT,IPLAN,JPLAN                                                        
      COMMON/ANGDIR/CC,SC,CO,SO,CP,SP                                           
      COMMON/CN/ICN(32)                                                         
      COMMON/TOMP/B(25,4),U(2),V(2),UZ(2)                                       
      COMMON/NEFACH/VOL                                                         
      COMMON/VOLT/TTAB,NWALT,NJIM,ABS1,ABS2                                     
      DIMENSION IX(3),XNSO(3),XN(3),SODU(3),XREN(3),WI(3,3)
      DATA XN,XNSO,SODU,XREN/12*0.0/                                            
      DATA RAD/57.2957794636/                                                   
      READ (5,*)ENTRPL,SORTPL,EXITPL                                            
      WRITE (6,888) ENTRPL ,SORTPL,EXITPL                                       
  888 FORMAT (5x,8HFICHIERS, 2X,A,2X,A,2X,A)                                    
      OPEN (UNIT=8,FILE=ENTRPL,STATUS='OLD',FORM='FORMATTED')                   
      OPEN (UNIT=4,FILE=SORTPL,STATUS='NEW',FORM='FORMATTED')                   
      OPEN (UNIT=2,FILE=EXITPL,STATUS='NEW',FORM='FORMATTED')                   
      OPEN (UNIT=3,STATUS='SCRATCH')                                            
      REWIND (8)                                                                
      REWIND (3)                                                                
      REWIND (4)                                                                
      REWIND (2)                                                                
   12 TBAR=0.                                                                   
      ABS=1.                                                                    
      ABS1=1.                                                                   
      ABS2=0.                                                                   
      TTAB=0.                                                                   
      NJIM=0                                                                    
      NWAJT=0                                                                   
      NREM=0                                                                    
      MULT=0                                                                    
      NREF=0                                                                    
      IDENT=0                                                                   
      IPU=0                                                                     
      READ (5,98)TIT                                                            
   98 FORMAT(20A4)                                                              
      IF(TIT(1).EQ.4H    ) GO TO 158                                            
      WRITE (6,100)TIT                                                          
  100 FORMAT('1',20A4)                                                          
      READ (5,*) (ICN(I),I=1,16)                                                
  102 FORMAT (16I3)                                                             
      WRITE (6,66)                                                              
   66 FORMAT (1H0,38H   CONTROL INTEGERS, ICN(1) - ICN(16) /)                   
      DO 14 I=1,16                                                              
   14 WRITE (6,68) I,ICN(I)                                                     
   68 FORMAT (5H ICN(,I2,4H) = ,I2)                                             
      IT=MOD(ICN(11),2)                                                         
      NMAX=ICN(10)                                                              
      IF(NMAX.GT.25) NMAX=25                                                    
      IF(ICN(8).EQ.1) CALL CARDIN(3)                                            
      CALL UMATRI                                                               
      WRITE (6,60) ((SHUFEL(I,J),J=1,3),I=1,3)                                  
   60 FORMAT (/47H THE WN MATRIX(BEDNOWITZ-COPPENS DEFINITION) IS/3(3F10        
     $.6/))                                                                     
      WRITE (6,62) W                                                            
   62 FORMAT (87H THE U MATRIX (HAMILTON DEFINITION, REFERRED TO NON-NOR        
     $MALIZED AXES, = W TRANSPOSE) IS /3(3F10.6/))                              
      WRITE (6,64)                                                              
   64 FORMAT (83H THE MATRIX USED IN AGNOST FOR ALL CALCULATIONS IS W, W        
     $HERE W = U TRANSPOSE (ABOVE))                                             
      CALL AMI3 (W,WI,DET)                                                      
      IF (ICN(7).GE.0) REWIND 4                                                 
      IF (ICN(7).GE.0) REWIND 2                                                 
      IF (ICN(8).NE.0) REWIND 3                                                 
      IF (ICN(9).LE.0) GO TO 20                                                 
      WRITE (6,74)                                                              
   74 FORMAT(/14H ANGLES CHECK /,3X,'H',3X,'K',3X,'L',2X,'TWO THETA',5X,        
     $'OMEGA',6X,'CHI',7X,'PHI',5X,'(SINT/L')                                   
      ND=ICN(9)                                                                 
      DO 18 I=1,ND                                                              
      READ (5,*)  X                                                             
   70 FORMAT (3F5.0)                                                            
      CALL DSTAR (X,DST)                                                        
      CALL ANGLES (OA,PHI,CHI,X,IERR,DST)                                       
      IF (IERR.EQ.1) GO TO 18                                                   
      CALL NORM (CHI)                                                           
      CALL NORM(OA)                                                             
      CALL NORM (PHI)                                                           
      SINT=DST*ELAMDA/2.                                                        
      TEMP=2.*RAD*ASIN(SINT)                                                    
      OA=(TEMP/2.)-OA                                                           
      WRITE (6,76)X,TEMP,OA,CHI,PHI,DST                                         
   76 FORMAT(1H ,3F4.0,5F10.4)                                                  
   18 CONTINUE                                                                  
   20 NFACES=ICN(6)                                                             
      IF(ICN(1).LT.0) GO TO 23                                                  
      IF(ICN(14).NE.0)WRITE (6,112)                                             
  112 FORMAT(' SETTING ANGLES READ FROM INPUT TAPE')                            
      READ (5,*) ((DATA(I,J),J=1,4),I=1,NFACES)                                 
   78 FORMAT (3F10.0,F10.4)                                                     
      WRITE(6,80)                                                               
   80 FORMAT(' BOUNDARY PLANES'/'    H    K    L        DIST')                  
      DO 22 I=1,NFACES                                                          
   22 WRITE (6,82) (DATA(I,J),J=1,4),I                                          
   82 FORMAT (1H ,3F4.0,F10.4,3X,I2)                                            
      CALL ANGLE (DATA,DIRECT,W,NFACES)                                         
      IF(ICN(15).EQ.0) CALL GRIT2                                               
   23 IF(ICN(5).NE.0) CALL MULREF                                               
      READ (5,*)EMU,SCALE                                                       
   84 FORMAT(3F10.6)                                                            
      WRITE (6,86)SCALE,EMU                                                     
   86 FORMAT (//15H  SCALE FACTOR=,F10.4/28H  ABSORPTION COEFFICIENT,MU=        
     $,F10.4)                                                                   
C....   BOUCLE DE CORRECTION DES REFLECTIONS                                    
   36 IF(MOD(NWALT,60).EQ.0) WRITE (6,106)                                      
  106 FORMAT(1H1,2X,'H',3X,'K',3X,'L',2X,'SCL',5X,'FOB',6X,'COFOB',5X,'S        
     $IG',7X,'CSIG',3X,'ABS',6X,'OM' ,6X,'CHI',7X,'PHI',6X,' THETA',2X,         
     $'NREF',1X,'TBAR',6X,'VOL')                                                
      CALL IMP                                                                  
      IF(IDENT.EQ.3) GO TO 58                                                   
      IF(ICN(14).NE.0) GO TO 43                                                 
      CALL DSTAR(X,DST)                                                         
      SINT=ELAMDA*DST/2.                                                        
      TETA=ASIN(SINT)*RAD                                                       
      COST=SQRT(1.-SINT*SINT)                                                   
      CALL ANGLES(OM,PHI,CHI,X,IERR,DST)                                        
      CALL NORM(OM)                                                             
      CALL NORM(PHI)                                                            
      CALL NORM(CHI)                                                            
      GO TO 44                                                                  
   43 TETA=TOTET/2.                                                             
C....  DECALAGE D ORIGINE DE OMEGA (OMEGA=0 EN BISSECTING POSITION )            
      OM=TETA-OM                                                                
      CALL NORM(OM)                                                             
      CALL NORM(PHI)                                                            
      CALL NORM(CHI)                                                            
      TETA1=TETA/RAD                                                            
      OM1=OM/RAD                                                                
      PHI1=PHI/RAD                                                              
      CHI1=CHI/RAD                                                              
      SINT=SIN(TETA1)                                                           
      COST=COS(TETA1)                                                           
      SC=SIN(CHI1)                                                              
      CC=COS(CHI1)                                                              
      SP=SIN(PHI1)                                                              
      CP=COS(PHI1)                                                              
      SO=SIN(OM1)                                                               
      CO=COS(OM1)                                                               
   44 IF(IDENT.EQ.1) GO TO 46                                                   
      CALL DIRCOS(XN,XNSO,SODU,TBAR,MULT,XREN,NREN)                             
      IF(IABS(ICN(1)).EQ.1) ABS=DSQRT(ABS)                                      
      IF(ICN(12).EQ.1) ABS=1.                                                   
      TTAB=TTAB+ABS                                                             
      ABS1=DMIN1(ABS,ABS1)                                                      
      ABS2=DMAX1(ABS,ABS2)                                                      
      NFLT=4H                                                                   
      IF(MULT.NE.0) NFLT=4H  *                                                  
      GO TO 47                                                                  
   46 ABS=1.                                                                    
      NJIM=NJIM+1                                                               
   47 FSQ=FSQD*SCALE/ABS                                                        
      SIGFSQ=SIGSQ*SCALE/ABS                                                    
      OM=TETA-OM                                                                
      STW=SINT/ELAMDA                                                           
      IF(IT.EQ.0) GO TO 54                                                      
   54 WRITE (6,104)X,SCALEN,FSQD,FSQ,SIGSQ,SIGFSQ,ABS,OM,CHI,PHI,TETA,          
     $NREF,TBAR,VOLUME,NFLT                                                     
  104 FORMAT(1X,4F4.0,4F10.2,F6.4,4F9.3,I5,F9.6,F10.7,A4)                       
      IF(NMAX.GT.1) WRITE(6,96)ABSO,(SN(I),I=1,NMAX)                            
   96 FORMAT(10E12.5)                                                           
      IF(ICN(11).GE.2) WRITE(6,95)(XN(I),I=1,3),(SODU(I),I=1,3)                 
     $,MULT,(XREN(I),I=1,3)                                                     
   95 FORMAT(  2(3F10.7,5X),10X,I5,3F5.0)                                       
      NWALT=NWALT+1                                                             
      IX(1)=X(1)                                                                
      IX(2)=X(2)                                                                
      IX(3)=X(3)                                                                
      IECHE=1                                                                   
      IF (NREF.EQ.JPLAN) IDENT=1                                                
      IF(ICN(7).EQ.0.AND.NMAX.EQ.0) WRITE(4,401) IDENT,X,FSQ,SIGFSQ,STW,        
     $XN,SODU,TBAR,MULT                                                         
  401 FORMAT (I1,3F4.0,2F9.3,F6.4,7F6.3,I1)                                     
      IF(ICN(7).EQ.0.AND.NMAX.EQ.0) WRITE (2,400) IX,FSQ,SIGFSQ,IECHE           
  400 FORMAT (3I4,2F8.2,I4)                                                     
      GO TO 36                                                                  
C....      FIN DE LA BOUCLE DE CORRECTION                                       
   58 CONTINUE                                                                  
      CALL AVARE                                                                
      IF(ICN(7).GE.0) ENDFILE 4                                                 
      IF (ICN(7).GE.0) REWIND 4                                                 
      IF (ICN(7).GE.0) ENDFILE 2                                                
      IF (ICN(7).GE.0) REWIND 2                                                 
      IF(ICN(5).NE.0) WRITE(6,101)NREN                                          
  101 FORMAT(///,' NOMBRE DE REFLECTIONS ENTACHEES DE MULTIPLES REFLECTI        
     $ONS : ',I5,///)                                                           
      GO TO 12                                                                  
  158 WRITE (6,108)                                                             
  108 FORMAT (1H0,30X,40HT H I S  I S  T H E  E N D.             )              
C.... LES 4 FORMATS QUI SUIVENT NE SERVENT A RIEN                               
   72 FORMAT (F9.4)                                                             
   88 FORMAT (1H1)                                                              
   90 FORMAT (3F10.7)                                                           
   92 FORMAT (F10.7)                                                            
C....                                                                           
      CLOSE (UNIT=8,STATUS='KEEP')                                              
      CLOSE (UNIT=4,STATUS='KEEP')                                              
      CLOSE (UNIT=2,STATUS='KEEP')                                              
      CLOSE (UNIT=3,STATUS='DELETE')                                            
      STOP                                                                      
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE AMI2 (A,B,DET)                                                 
C                                                                               
C.... INVERTS ASYMMETRIC 2X2 MATRIX                                             
C                                                                               
      DIMENSION A(2,2), B(2,2)                                                  
      DET=A(1,1)*A(2,2)-A(1,2)*A(2,1)                                           
      IF (DET) 12,14,12                                                         
   12 B(1,1)=A(2,2)/DET                                                         
      B(1,2)=-A(1,2)/DET                                                        
      B(2,1)=-A(2,1)/DET                                                        
      B(2,2)=A(1,1)/DET                                                         
   14 RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE AMI3 (A,B,DET)                                                 
C                                                                               
C.... INVERTS ASYMMETRIC 3X3 MATRIX                                             
C                                                                               
      DIMENSION A(3,3), B(3,3)                                                  
      B(1,1)=A(2,2)*A(3,3)-A(3,2)*A(2,3)                                        
      B(2,1)=A(2,1)*A(3,3)-A(3,1)*A(2,3)                                        
      B(3,1)=A(2,1)*A(3,2)-A(3,1)*A(2,2)                                        
      DET=A(1,1)*B(1,1)-A(1,2)*B(2,1)+A(1,3)*B(3,1)                             
      IF (DET) 12,16,12                                                         
   12 B(1,2)=A(1,2)*A(3,3)-A(3,2)*A(1,3)                                        
      B(2,2)=A(1,1)*A(3,3)-A(3,1)*A(1,3)                                        
      B(3,2)=A(1,1)*A(3,2)-A(3,1)*A(1,2)                                        
      B(1,3)=A(1,2)*A(2,3)-A(2,2)*A(1,3)                                        
      B(2,3)=A(1,1)*A(2,3)-A(2,1)*A(1,3)                                        
      B(3,3)=A(1,1)*A(2,2)-A(2,1)*A(1,2)                                        
      DO 14 I=1,3                                                               
      DO 14 J=1,3                                                               
   14 B(I,J)=(-1.)**(I+J)*B(I,J)/DET                                            
   16 RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE ANGLE (A,G,W,KP)                                               
C                                                                               
      COMMON/TOMP/B(25,4),U(2),V(2),UZ(2)                                       
      DIMENSION A(25,4),GU(3,3),T2(3,3),C1(3),C2(3),G(3,3),W(3,3)               
      DO 12 I=1,3                                                               
      DO 12 J=1,3                                                               
   12 T2(I,J)=W(J,I)                                                            
      CALL MAM (G,T2,GU)                                                        
      CALL AMI3 (GU,T2,DET)                                                     
      DO 20 J=1,KP                                                              
      DO 14 I=1,3                                                               
   14 C1(I)=A(J,I)                                                              
      CALL MV (T2,C1,C2)                                                        
      QZ=0.0                                                                    
      DO 16 K=1,3                                                               
   16 QZ=QZ+C2(K)**2                                                            
      QZ=SQRT(QZ)                                                               
      DO 18 K=1,3                                                               
   18 B(J,K)=C2(K)/QZ                                                           
      B(J,4)=A(J,4)                                                             
   20 CONTINUE                                                                  
      WRITE (6,28)                                                              
   28 FORMAT(///,' TRANSFORMED PLANES',//,4X,'     A(1) X    +    A(2) Y        
     $    +    A(3) Z    +    A(4)    =    0',//)                               
      DO 22 J=1,KP                                                              
   22 WRITE(6,30) (B(J,I),I=1,4),J                                              
   30 FORMAT (4F15.8,3X,I2)                                                     
      WRITE (6,32)                                                              
   32 FORMAT(///,' INTERPLANAR ANGLES IN DEGREES',//,' PLANE 1  PLANE 2         
     $ ANGLE',/)                                                                
      I1=KP-1                                                                   
      DO 26 I=1,I1                                                              
      J=I+1                                                                     
      DO 26 K=J,KP                                                              
      S=0.                                                                      
      DO 24 L=1,3                                                               
   24 S=S+B(I,L)*B(K,L)                                                         
      IF (ABS(S).LT.1.001.AND.ABS(S).GT.1.000) S=1.0*SIGN(1.0,S)                
      ANG=57.2958*ACOS(S)                                                       
   26 WRITE (6,34) I,K,ANG                                                      
   34 FORMAT (I5,I9,F10.2)                                                      
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE ANGLES (OMEGA,PHI,CHI,X,IERR,DST)                              
C                                                                               
C.... CALCULATES DIFFRACTOMETER SETTING ANGLES GIVEN OMEGA                      
C                                                                               
      COMMON /A/ RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)        
     $,WI(3,3)                                                                  
      COMMON/CN/ICN(32)                                                         
      COMMON /ANGDIR/ CCHI,SCHI,C,A,CPHI,SPHI                                   
      DIMENSION X(3), E(3)                                                      
      DATA RAD/57.2957795/                                                      
      DATA PI/3.1415926563/                                                     
      DO 14 I=1,3                                                               
      E(I)=0.                                                                   
      DO 12 J=1,3                                                               
   12 E(I)=E(I)+W(I,J)*X(J)                                                     
   14 E(I)=E(I)/DST                                                             
      IERR=0                                                                    
      IF (ICN(3).EQ.0) GO TO 36                                                 
      CHI=0.5*PI                                                                
      IF(ABS(E(3)).GT.1.) GO TO 64                                              
      GO TO 16                                                                  
   16 OMEGA=2.*PI-ACOS(-(E(3)))                                                 
      CPHI=-E(1)/SIN(OMEGA)                                                     
      SPHI=E(2)/SIN(OMEGA)                                                      
      IF(CPHI.GT.1..OR.SPHI.GT.1.) GO TO 64                                     
      GO TO 22                                                                  
   22 IF(E(1).GT.0.) GO TO 24                                                   
      GO TO 26                                                                  
   24 IF(E(2).GT.0.) GO TO 28                                                   
      GO TO 30                                                                  
   26 IF(E(2).GT.0.) GO TO 32                                                   
      GO TO 34                                                                  
   28 PHI=2.*PI-ACOS(CPHI)                                                      
      GO TO 35                                                                  
   30 PHI=ACOS(CPHI)                                                            
      GO TO 35                                                                  
   32 PHI=PI+ASIN(ABS(SPHI))                                                    
      GO TO 35                                                                  
   34 PHI=PI-ASIN(ABS(SPHI))                                                    
   35 OMEGA=OMEGA*RAD                                                           
      PHI=PHI*RAD                                                               
      CHI=90.                                                                   
      GO TO 62                                                                  
   36 OMEGA=0.                                                                  
      C=ABS(COS(OMEGA/RAD))                                                     
      IF (C-0.000001) 38,38,42                                                  
   38 IF (ABS(E(3))-0.000001) 40,40,64                                          
   40 CHI=0.0                                                                   
      CPHI=E(1)                                                                 
      SPHI=-E(2)                                                                
      GO TO 58                                                                  
   42 SCHI=-E(3)/C                                                              
      IF(ABS(SCHI).GT.1.000001) GO TO 64                                        
      IF(ABS(SCHI).GT.1.) SCHI=SIGN(1.,SCHI)                                    
   44 A=SIN(OMEGA/RAD)                                                          
      CCHI=SQRT(1.0-SCHI**2)                                                    
      CHI=ASIN(SCHI)*RAD                                                        
      B=C*CCHI                                                                  
      DENO=A**2+B**2                                                            
      IF (DENO-0.000001) 46,46,48                                               
   46 PHI=0.0                                                                   
      GO TO 62                                                                  
   48 CPHI=(A*E(1)+B*E(2))/DENO                                                 
      IF(ABS(CPHI)-1.000001) 50,50,65                                           
   50 IF (B-0.0000001) 52,52,54                                                 
   52 SPHI=-E(2)/A                                                              
      GO TO 56                                                                  
   54 SPHI=(E(1)-A*CPHI)/B                                                      
   56 IF(ABS(SPHI).GT.1.000001) GO TO 67                                        
      IF(ABS(SPHI).GT.1.) SPHI=SIGN(1.,SPHI)                                    
   58 PHI=ASIN(SPHI)*RAD                                                        
      IF (CPHI) 60,62,62                                                        
   60 PHI=180.-PHI                                                              
   62 RETURN                                                                    
   65 PHI=0.                                                                    
      RETURN                                                                    
   67 PHI=90.                                                                   
      RETURN                                                                    
   64 PHI=0.0                                                                   
      CHI=0.0                                                                   
      WRITE(6,66) X                                                             
   66 FORMAT (/20H  SKIPPED REFLECTION,3F4.0,39H  HERE BECAUSE OF IMPOSS        
     $IBLE CHI OR PHI/)                                                         
      IERR=1                                                                    
      GO TO 62                                                                  
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE AVARE                                                          
C                                                                               
      COMMON/VOLT/TTAB,NWALT,NJIM,ABS1,ABS2                                     
      WRITE (6,96)NWALT                                                         
   96 FORMAT(' NUMBER OF REFLECTIONS AT THIS POINT IS',I6)                      
      AVABS=FLOAT(NWALT-NJIM)/TTAB                                              
      WRITE (6,107)AVABS                                                        
  107 FORMAT(' AVERAGE ABSORPTION CORRECTION IS',F10.5)                         
      WRITE (6,111)ABS1,ABS2                                                    
  111 FORMAT(' MINIMUN ABS =',F7.3,'MAXIMUM ABS =',F7.3)                        
      WRITE (6,109)AVABS                                                        
  109 FORMAT(' MULTIPLY LEAST SQUARES SCALE FACTOR BY',F10.5)                   
      ABS1=1.                                                                   
      ABS2=0.                                                                   
      TTAB=0.                                                                   
      NJIM=0                                                                    
      NWALT=0                                                                   
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      FUNCTION BLENGT(KA,KB)                                                    
C                                                                               
      COMMON/A/RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)          
     $,WI(3,3)                                                                  
      COMMON/DSTN/A(3,100)                                                      
      DIMENSION DIR(3),REC(3)                                                   
      BLENGT=0.0                                                                
      DO 12 I=1,3                                                               
   12 DIR(I)=A(I,KA)-A(I,KB)                                                    
      CALL VM(DIR,DIRECT,REC)                                                   
      DO 14 J=1,3                                                               
   14 BLENGT=BLENGT+DIR(J)*REC(J)                                               
      BLENGT=SQRT(BLENGT)                                                       
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE CARDIN(IN)                                                     
C                                                                               
      COMMON/REFL/X(3),SCALEN,FSQD,SIGSQ,CHI,CINT,GCOR,NREF,TOTET,OM,PHI        
     $,IDENT,IPLAN,JPLAN                                                        
C.... CREATION D'UN FICHIER BINAIRE DE NUMERO LOGIQUE IN A PARTIR D'UN          
C     FICHIER CONTENANT N PLANS PAR LIGNES                                      
      DIMENSION IX(3,8),F(8),SIG(8)
      READ (5,*)  N                                                             
      WRITE (6,9)  N                                                            
    8 FORMAT (I5)                                                               
    9 FORMAT ('LECTURE DE',I3,' PLAN(S) PAR LIGNE')                             
      IF(N.GT.8) STOP10                                                         
      IPLAN=0                                                                   
    1 READ (5,*,ERR=100,END=100) ((IX(I,J),I=1,3),F(J),SIG(J),J=1,N)            
      IF (IX(1,1).GE.500) GOTO 100                                              
      IPLAN=IPLAN+1                                                             
      DO 2 J=1,N                                                                
      X(1)=IX(1,J)                                                              
      X(2)=IX(2,J)                                                              
      X(3)=IX(3,J)                                                              
      IF(X(1).EQ.0..AND.X(2).EQ.0..AND.X(3).EQ.0.) GO TO 2                      
      WRITE(IN)   X,F(J),SIG(J)                                                 
    2 CONTINUE                                                                  
      GO TO 1                                                                   
  100 ENDFILE IN                                                                
      REWIND IN                                                                 
      JPLAN=IPLAN                                                               
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE DIRCOS(XN,XNSO,SODU,TBAR,MULT,XREN,NREN)                       
C                                                                               
C.... DETERMINES COMPONENTS OF INCIDENT AND DIFFRACTED BEAMS AND COMPONE        
C.... OF NORMAL TO DIFFRACTION PLANE AND NORMAL TO INCIDENT BEAM IN             
C.... DIFFRACTION PLANE                                                         
C.... SUBSIDIARY SUBROUTINE LENGTH2 FOR CALCULATION OF ABSORPTION               
C.... SOD AND SD ARE THE COMPONENTS OF THE INCIDENT AND DIFFRACTED RAYS         
C.... DIRECT SPACE                                                              
C.... SO AND S ARE THE COMPONENTS OF THE INCIDENT AND DIFFRACTED RAYS IN        
C.... CAL SP1CE                                                                 
C                                                                               
C.... SODU EST UN VECTEUR UNITAIRE DANS LA DIRECTION INCIDENTE                  
      REAL*8 ABS,VOL                                                            
      DIMENSION XN(3), XNSO(3), SOD(3), SD(3), TN(3), T(3)                      
      DIMENSION S(3),SO(3),R(3,3),WI(3,3),RT(3,3),TT(3)                         
      DIMENSION SODU(3)                                                         
      DIMENSION   XREN(3)                                                       
      COMMON/D/ELAMDA,COST,SINT,EMU,NPOINT,TETA                                 
      COMMON /A/ RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)        
     $,WI                                                                       
      COMMON/C/DATA(25,4)                                                       
      COMMON/E/ABS,VOL,NFACES,UM,EXT,FAULT                                      
      COMMON/CN/ICN(32)                                                         
      COMMON /ANGDIR/ COSCHI,SINCHI,COSOMT,SINOMT,COSPHI,SINPHI                 
      COMMON/TOMP/B(25,4),U(2),V(2),UZ(2)                                       
      R(1,1)=+COSPHI*COSOMT+SINPHI*COSCHI*SINOMT                                
      R(1,2)=-COSPHI*SINOMT+SINPHI*COSCHI*COSOMT                                
      R(2,1)=-SINPHI* COSOMT+COSPHI*COSCHI*SINOMT                               
      R(2,2)=+SINPHI*SINOMT+COSPHI*COSCHI*COSOMT                                
      R(3,1)=-SINCHI*SINOMT                                                     
      R(3,2)=-SINCHI*COSOMT                                                     
      R(1,3)=0.                                                                 
      R(2,3)=0.                                                                 
      R(3,3)=0.                                                                 
      DO 12 I=1,3                                                               
      DO 12 J=1,3                                                               
      RT(I,J)=0.                                                                
      DO 12 K=1,3                                                               
   12 RT(I,J)=RT(I,J)+WI(I,K)*R(K,J)                                            
      T(1)=-COST                                                                
      T(2)=-SINT                                                                
      T(3)=0.                                                                   
      TT(1)=-COST                                                               
      TT(2)=-T(2)                                                               
      TT(3)=0.                                                                  
      DO 14 I=1,3                                                               
      SO(I)=0.                                                                  
      S(I)=0.                                                                   
      DO 14 J=1,3                                                               
      SO(I)=RT(I,J)*T(J)+SO(I)                                                  
   14 S(I)=RT(I,J)*TT(J)+S(I)                                                   
      DO 16 I=1,3                                                               
      SD(I)=0.                                                                  
      SOD(I)=0.                                                                 
      DO 16 J=1,3                                                               
      SOD(I)=SOD(I)+RECIP(I,J)*SO(J)                                            
   16 SD(I)=SD(I)+RECIP(I,J)*S(J)                                               
      IF(ICN(5).EQ.0) GO TO 17                                                  
      CALL RENING(SO,S,MULT,XREN,NREN)                                          
   17 IF(ICN(2).EQ.0) GO TO 22                                                  
      IF(ICN(15).NE.0)GO TO 19                                                  
      FNORM=0.                                                                  
      DO 20 I=1,3                                                               
   20 FNORM=FNORM+SOD(I)*SO(I)                                                  
      FNORM=SQRT(FNORM)                                                         
      DO 21 I=1,3                                                               
   21 SODU(I)=SOD(I)*DRC(I)/FNORM                                               
      CALL NORMAL (SD,SOD,XN)                                                   
      DO 18 I=1,3                                                               
   18 TN(I)=XN(I)/DRC(I)                                                        
      CALL NORMAL (TN,SOD,XNSO)                                                 
   22 IF(ICN(1).GT.0) CALL LENGTH(SD,SOD,TBAR)                                  
      IF(ICN(1).LT.0) CALL SPHERE(TBAR)                                         
      RETURN                                                                    
   19 WRITE (6,100)                                                             
  100 FORMAT(//,' LA METHODE ANALYTIQUE EST PROVISOIREMENT SUPPRIMEE')          
      STOP 6                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE DISTA(MM)                                                      
C                                                                               
      COMMON/CN/ICN(32)                                                         
      WRITE (6,18)                                                              
   18 FORMAT (//30X,40HDISTANCES BETWEEN POINTS OF INTERSECTION//)              
      IF(ICN(4).GT.1)GO TO 14                                                   
   12 READ (5,*)KA,KB                                                           
   20 FORMAT(2I5)                                                               
      IF(KA.EQ.KB)RETURN                                                        
      BRA=BLENGT(KA,KB)                                                         
      WRITE(6,22)KA,KB,BRA                                                      
   22 FORMAT (26X,16HDISTANCE BETWEEN,I5,5H  AND,I5,3H  =,F10.7,2X,2HCM)        
      GO TO 12                                                                  
   14 DO 16 KA=1,MM                                                             
      KC=KA+1                                                                   
      DO 16 KB=KC,MM                                                            
      IF(KC.GT.MM)RETURN                                                        
      BRA=BLENGT(KA,KB)                                                         
   16 WRITE (6,22)KA,KB,BRA                                                     
      RETURN                                                                    
      END                                                                       
C************************************************************************       
C                                                                               
      SUBROUTINE DSTAR (X,DST)                                                  
C                                                                               
      COMMON /A/ RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)        
     $,WI(3,3)                                                                  
      DIMENSION X(3)                                                            
      REAL H,K,L                                                                
      H=X(1)                                                                    
      K=X(2)                                                                    
      L=X(3)                                                                    
      DST=(H*RCP(1))**2+(K*RCP(2))**2+(L*RCP(3))**2+2.*(H*K*RCP(1)*RCP(2        
     $)*RCP(6)+H*L*RCP(1)*RCP(3)*RCP(5)+K*L*RCP(2)*RCP(3)*RCP(4))               
      DST=SQRT(DST)                                                             
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE GRIT2                                                          
C                                                                               
C....  CONSTRUCTS GAUSSIAN GRID WITHIN CRYSTAL. GRID AXES PARALLEL TO XTA       
C                                                                               
      REAL*8 ABSO,VOLUME,VOL                                                    
      REAL*8 GRID(4,4000)                                                       
      REAL*8 ERIC1(64),ERIC2(64),ERIC3(64),ERIC4(64),ERICH(256)                 
      REAL*8 GAUSS(128,2),XX(50),R1,R2                                          
      REAL*8 XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,DELTAZ                               
      COMMON EPOA,EPOB,GRID                                                     
      COMMON /A/ RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)        
     $,WI(3,3)                                                                  
      COMMON/C/DATA(25,4)                                                       
      COMMON/D/ELAMDA,COST,SINT,EMU,NPOINT,TETA                                 
      COMMON/E/ABSO,VOLUME,NFACES,UM,EXT,FAULT                                  
      COMMON/CN/ICN(32)                                                         
      COMMON /DSTN/ XOZ(3,100)                                                  
      COMMON /NEFACH/VOL,CHECK                                                  
      DIMENSION XYZ(3)                                                          
      DIMENSION GU(3,3), XUZ(3),XCZ(3)                                          
      DIMENSION NADRES(3),ABOUND(3,3),DIST(3)                                   
      DIMENSION BBOUND(2,2),DI(2),TEMP(3)                                       
      DIMENSION CBOUND(3,3),DBOUND(2,2),NGAUSS(3),SUM(25)                       
      EQUIVALENCE (ERICH(1),ERIC1(1)),(ERICH(65),ERIC2(1)),                     
     $(ERICH(129),ERIC3(1)),(ERICH(193),ERIC4(1))                               
      EQUIVALENCE (GAUSS,ERICH)                                                 
      DATA IA,IB,IC/1,2,3/                                                      
C                                                                               
C....  FOLLOWING ARE THE TABLES FOR THE GAUSSIAN INTEGRATION                    
C                                                                               
      DATA  ERIC1           /.2113248660,.7886751350,.0694318440,.330009        
     14780,.6699905220,.9305681560,.0337652430,.1693953070,.3806904070,.        
     26193095930,.8306046930,.9662347570,.0198550720,.1016667610,.237233        
     37950,.4082826790,.5917173210,.7627662050,.8983332390,.9801449280,.        
     40130467360,.0674683170,.1602952160,.2833023030,.4255628310,.574437        
     51700,.7166976970,.8397047840,.9325316830,.9869532640,.0092196830,.        
     60479413720,.1150486630,.2063410230,.3160842510,.4373332960,.562666        
     77040,.6839157500,.7936589770,.8849513370,.9520586280,.9907803170,.        
     80068580960,.0357825580,.0863993420,.1563535480,.2423756820,.340443        
     98160,.4459725260,.5540274740,.6595561840,.7576243180,.8436464520,.        
     $9136006580,.9642174420,.9931419040,.0052995330,.0277124880,.067184        
     $3990,.1222977960,.1910618780,.2709916110,.3591982250,.4524937450/         
      DATA  ERIC2             /.5475062550,.6408017750,.7290083890,.8089        
     1381220,.8777022040,.9328156010,.9722875120,.9947004680,.9975936100        
     2,.9873642780,.9691372760,.9432077640,.9100009930,.8700620960,.8240        
     3468260,.7727107360,.7168967540,.6575213400,.5955594340,.5320284470        
     4,.4679715530,.4044405660,.3424786600,.2831032460,.2272892640,.1759        
     5531740,.1299379040,.0899990070,.0567922360,.0308627240,.0126357220        
     6,.0024063900,.9986319310,.9928057560,.9823811280,.9674530380,.9481        
     7605780,.9246838070,.8972418980,.8660910600,.8315221340,.7938578790        
     8,.7534499550,.7106756380,.6659343010,.6196436810,.5722359810,.5241        
     9538330,.4758461670,.4277640190,.3803563190,.3340656990,.2893243620        
     $,.2465500450,.2061421210,.1684778670,.1339089400,.1027581020,.0753        
     $161930,.0518394220,.0325469620,.0176188720,.0071942440,.0013680690        
     $/                                                                         
      DATA  ERIC3              /.5000000000,.5000000000,.1739274230,.326        
     10725780,.3260725780,.1739274230,.0856622460,.1803807870,.233956967        
     20,.2339569670,.1803807870,.0856622460,.0506142680,.1111905170,.156        
     38533230,.1813418920,.1813418920,.1568533230,.1111905170,.050614268        
     40,.0333356720,.0747256750,.1095431810,.1346333600,.1477621120,.147        
     57621120,.1346333600,.1095431810,.0747256750,.0333356720,.023587668        
     60,.0534696630,.0800391640,.1015837130,.1167462680,.1245735230,.124        
     75735230,.1167462680,.1015837130,.0800391640,.0534696630,.023587668        
     80,.0175597300,.0400790440,.0607592850,.0786015840,.0927691990,.102        
     95992320,.1076319270,.1076319270,.1025992320,.0927691990,.078601584        
     $0,.0607592850,.0400790440,.0175597300,.0135762300,.0311267620,.047        
     $5792560,.0623144860,.0747979940,.0845782600,.0913017080,.094725305        
     $0/                                                                        
      DATA  ERIC4              /.0947253050,.0913017080,.0845782600,.074        
     17979940,.0623144860,.0475792560,.0311267620,.0135762300,.006170615        
     20,.0142656940,.0221387190,.0296492920,.0366732410,.0430950810,.048        
     38093260,.0537221350,.0577528340,.0608352360,.0629187280,.063969098        
     40,.0639690980,.0629187280,.0608352360,.0577528340,.0537221350,.048        
     58093260,.0430950810,.0366732410,.0296492920,.0221387190,.014265694        
     60,.0061706150,.0035093050,.0081371970,.0126960330,.0171369320,.021        
     74179490,.0254990300,.0293420470,.0329111110,.0361728970,.039096948        
     80,.0416559620,.0438260470,.0455869390,.0469221990,.0478193600,.048        
     92700440,.0482700440,.0478193600,.0469222000,.0455869390,.043826047        
     $0,.0416559620,.0390969480,.0361728970,.0329111110,.0293420470,.025        
     $4990300,.0214179490,.0171369320,.0126960330,.0081371970,.003509305        
     $0/                                                                        
      IABS=ICN(1)                                                               
      IEXT=ICN(2)                                                               
      AX=0.                                                                     
      AY=0.                                                                     
      AZ=0.                                                                     
      XOMI=100.                                                                 
      YOMI=100.                                                                 
      ZOMI=100.                                                                 
      XOMA=-100.                                                                
      YOMA=-100.                                                                
      ZOMA=-100.                                                                
      READ (5,*)(NGAUSS(I),I=1,3),IPRINT                                        
   64 FORMAT(4I5)                                                               
      IGRID=NGAUSS(1)*NGAUSS(2)*NGAUSS(3)+1                                     
      IF(ICN(16).EQ.1)GO TO 20                                                  
   12 CALL MAM (W,DIRECT,GU)                                                    
C                                                                               
C....  DETERMINE LENGTHS OF RECIPROCAL VECTORS PERPENDICULAR TO BOUNDARY        
C                                                                               
      DO 18 I=1,NFACES                                                          
      DO 14 J=1,3                                                               
      TEMP(J)=0.                                                                
      DO 14 K=1,3                                                               
   14 TEMP(J)=TEMP(J)+DATA(I,K)*RECIP(K,J)                                      
      SUM(I)=0.                                                                 
      DO 16 L=1,3                                                               
   16 SUM(I)=SUM(I)+TEMP(L)*DATA(I,L)                                           
      SUM(I)=SQRT(SUM(I))                                                       
C                                                                               
C....  MULTIPLY DISTANCE FROM ORIGIN TO FACE BY LENGTH OF RECIPROCAL VE         
C....  NORMAL TO FACE,INSTEAD OF NORMALIZING THIS VECTOR TO UNITY BY DI         
C....  H,K AND L BY LENGTH                                                      
C                                                                               
      DATA (I,4)=DATA(I,4)*SUM(I)                                               
   18 CONTINUE                                                                  
C                                                                               
C....  FIND FIRST ADDRESS OF GAUSSIAN CONSTANTS TO BE USED                      
C                                                                               
   20 DO 26 I=1,3                                                               
      K=NGAUSS(I)/2                                                             
      IF (K-8) 22,22,24                                                         
   22 NADRES(I)=(K-1)*K                                                         
      GO TO 26                                                                  
   24 NADRES(I)=72+(K-12)*6                                                     
   26 CONTINUE                                                                  
      MM=0                                                                      
      NPOINT=0                                                                  
      VOL=0.                                                                    
C                                                                               
C....  SCAN OVER ALL POSSIBLE COMBINATIONS OF THREE FACES TO DETERMINE CO       
C....  TES OF CORNERS OF CRYSTAL                                                
C                                                                               
      N1=NFACES-1                                                               
      N2=NFACES-2                                                               
      WRITE(6,66)                                                               
   66 FORMAT (77H SHAPE OF CRYSTAL WHEN POSITIONED AT DISPLAY ANGLES - O        
     $MEGA , CHI AND PHI =0./46H POINTS OF INTERSECTION OF TRANSFORMED P        
     $LANES /28H      X          Y        Z  ,69X,'A',8X,'B',8X,'C'/10X,        
     $'B N L SPACE',78X,'CRYSTAL SPACE'/)                                       
      DO 40 K=1,N2                                                              
      DO 28 I=1,3                                                               
   28 ABOUND(1,I)=DATA(K,I)                                                     
      K1=K+1                                                                    
      DO 40 L=K1,N1                                                             
      DO 30 I=1,3                                                               
   30 ABOUND(2,I)=DATA(L,I)                                                     
      L1=L+1                                                                    
      DO 40 M=L1,NFACES                                                         
      DO 32 I=1,3                                                               
   32 ABOUND(3,I)=DATA(M,I)                                                     
      CALL AMI3 (ABOUND,CBOUND,DET)                                             
      IF (DET) 34,40,34                                                         
   34 DIST(1)=DATA(K,4)                                                         
      DIST(2)=DATA(L,4)                                                         
      DIST(3)=DATA(M,4)                                                         
      CALL MV (CBOUND,DIST,XYZ)                                                 
C                                                                               
C....  CHECK WHETHER POINT IS ON CRYSTAL SURFACE, IF OUTSIDE CRYSTAL RE         
C....  XYZ ARE FRACTIONAL COORDINATES OF THE POINT OF INTERSECTION OF 3         
C....  SINCE THE DISTANCES FROM THE ORIGIN TO EACH OF THE FACES ARE GIV         
C....  THE COORDINATES XYZ ARE FRACTIONS OF AXES A,B,C OF LENGTH A(CM),         
C                                                                               
      CALL INSIDE (XYZ,NOUT,NFACES,DATA)                                        
      IF (NOUT) 40,36,40                                                        
   36 MM=MM+1                                                                   
      CALL MV (GU,XYZ,XUZ)                                                      
      DO 37 IK=1,3                                                              
   37 XCZ(IK)=XYZ(IK)*DRC(IK)                                                   
      DUM=XCZ(3)                                                                
      ZOMI=AMIN1(DUM,ZOMI)                                                      
      ZOMA=AMAX1(DUM,ZOMA)                                                      
      DUM=XCZ(2)                                                                
      YOMI=AMIN1(DUM,YOMI)                                                      
      YOMA=AMAX1(DUM,YOMA)                                                      
      DUM=XCZ(1)                                                                
      XOMI=AMIN1(DUM,XOMI)                                                      
      XOMA=AMAX1(DUM,XOMA)                                                      
      WRITE(6,68) XUZ,(DATA(K,I),I=1,3),(DATA(L,I),I=1,3),(DATA(M,I),I=1        
     $,3),MM,XCZ                                                                
   68 FORMAT (3F10.5, 2X,23H INTERSECTION OF PLANES,3F4.0,2H ,,3F4.0,4H         
     $AND,3F4.0,I3,2X,3F9.5)                                                    
      XX(MM)=XYZ(IA)                                                            
      DO 38 IJ=1,3                                                              
   38 XOZ(IJ,MM)=XYZ(IJ)                                                        
   40 CONTINUE                                                                  
      IF(ICN(4).EQ.0) GO TO 42                                                  
      CALL DISTA(MM)                                                            
   42 IF (IABS.EQ.0.AND.IEXT.EQ.0) STOP 7                                       
      IF(IPRINT.NE.0) WRITE (6,2000)                                            
 2000 FORMAT(///,' GRILLE CHOISIE',//,10X,'X',18X,'Y',20X,'Z',14X,'POIDS        
     $ GAUSSIEN',//)                                                            
C                                                                               
C....  DETERMINE LOWER AND UPPER LIMITS IN X                                    
C                                                                               
      CALL MINMAX (XX,MM,XMIN,XMAX)                                             
      NIA=NGAUSS(IA)                                                            
      DO 60 NPA=1,NIA                                                           
C                                                                               
C....  XYZ(IA) ARE FRACTIONAL COORDINATES OF GRID POINTS ALONG A AXIS           
C                                                                               
      IF (NIA-1) 46,46,44                                                       
   44 XYZ(IA)=XMIN+(XMAX-XMIN)*GAUSS((NADRES(IA)+NPA),1)                        
C                                                                               
C....  R1 IS THE GAUSSIAN WEIGHT CORRESPONDING TO XYZ(IA)                       
C                                                                               
      R1=GAUSS((NADRES(IA)+NPA),2)*(XMAX-XMIN)                                  
   46 MM=0                                                                      
C                                                                               
C....  SCAN OVER ALL POSSIBLE COMBINATIONS OF TWO FACES TO DETERMINE CO         
C....  OF EDGES OF CRYSTAL FOR A GIVEN X                                        
C                                                                               
      DO 52 K=1,N1                                                              
      BBOUND(1,1)=DATA(K,IB)                                                    
      BBOUND(1,2)=DATA(K,IC)                                                    
      DI(1)=DATA(K,4)-DATA(K,IA)*XYZ(IA)                                        
      K1=K+1                                                                    
      DO 52 L=K1,NFACES                                                         
      BBOUND(2,1)=DATA(L,IB)                                                    
      BBOUND(2,2)=DATA(L,IC)                                                    
      CALL AMI2 (BBOUND,DBOUND,DET)                                             
      IF (DET) 48,52,48                                                         
   48 DI(2)=DATA(L,4)-DATA(L,IA)*XYZ(IA)                                        
      XYZ(IB)=DBOUND(1,1)*DI(1)+DBOUND(1,2)*DI(2)                               
      XYZ(IC)=DBOUND(2,1)*DI(1)+DBOUND(2,2)*DI(2)                               
      CALL INSIDE (XYZ,NOUT,NFACES,DATA)                                        
      IF (NOUT) 52,50,52                                                        
   50 MM=MM+1                                                                   
      XX(MM)=XYZ(IB)                                                            
   52 CONTINUE                                                                  
C                                                                               
C....  DETERMINE LOWER AND UPPER LIMITS IN Y FOR GIVEN X                        
C                                                                               
      CALL MINMAX (XX,MM,YMIN,YMAX)                                             
      NIB=NGAUSS(IB)                                                            
      DO 60 NPB=1,NIB                                                           
      XYZ(IB)=YMIN+(YMAX-YMIN)*GAUSS((NADRES(IB)+NPB),1)                        
      R2=GAUSS((NADRES(IB)+NPB),2)*R1*(YMAX-YMIN)                               
      MM=0                                                                      
C                                                                               
C....  SCAN OVER ALL FACES TO DETERMINE UPPER AND LOWER LIMITS OF Z FOR         
C                                                                               
      DO 58 I=1,NFACES                                                          
      IF (DATA(I,IC)) 54,58,54                                                  
   54 XYZ(IC)=(DATA(I,4)-XYZ(IA)*DATA(I,IA)-XYZ(IB)*DATA(I,IB))/DATA            
     $(I,IC)                                                                    
      CALL INSIDE (XYZ,NOUT,NFACES,DATA)                                        
      IF (NOUT) 58,56,58                                                        
   56 MM=MM+1                                                                   
      XX(MM)=XYZ(IC)                                                            
   58 CONTINUE                                                                  
      CALL MINMAX (XX,MM,ZMIN,ZMAX)                                             
      NIC=NGAUSS(IC)                                                            
      DELTAZ=ZMAX-ZMIN                                                          
      DO 60 NPC=1,NIC                                                           
      NPOINT=NPOINT+1                                                           
C                                                                               
C....  STORE FRACTIONAL COORDINATES OF SAMPLING POINTS AND CORRESPONDIN         
C                                                                               
      GRID(IA,NPOINT)=XYZ(IA)                                                   
      GRID(IB,NPOINT)=XYZ(IB)                                                   
      GRID(IC,NPOINT)=ZMIN+DELTAZ*GAUSS((NADRES(IC)+NPC),1)                     
      GRID(4,NPOINT)=GAUSS((NADRES(IC)+NPC),2)*R2*DELTAZ                        
      IF(IPRINT.NE.0) WRITE(6,1000)(GRID(II,NPOINT),II=1,4)                     
 1000 FORMAT(1H ,4F20.15)                                                       
C                                                                               
C....  VOL IS EQUAL TO THE VOLUME OF THE CRYSTAL AS A FRACTION OF THE V         
C....  A PARALLELOPIPED WHOSE EDGES ARE PARALLEL TO A,B,C AND OF LENGTH         
C....  B(CMS),C(CMS)                                                            
C                                                                               
      VOL=VOL+GRID(4,NPOINT)                                                    
   60 CONTINUE                                                                  
      AX=XOMA-XOMI                                                              
      AY=YOMA-YOMI                                                              
      AZ=ZOMA-ZOMI                                                              
      WRITE (6,70) AX,AY,AZ                                                     
   70 FORMAT (//10X,55HMAXIMUM DIMENSIONS OF CRYSTAL ALONG DIRECT CRYSTA        
     $L AXES/5X,8HALONG A ,F7.5/5X,8HALONG B ,F7.5/5X,8HALONG C ,F7.5/)         
   62 WRITE (6,76)(NGAUSS(I),I=1,3),NPOINT                                      
   76 FORMAT (8H0N(1) = ,I2,9H  N(2) = ,I2,9H  N(3) = ,I2,36H          N        
     $UMBER OF SAMPLING POINTS ,I6)                                             
      SINIA=SQRT(1.-DRC(IA+3)**2)                                               
      CLES=DRC(IB)*DRC(IC)*SINIA/RCP(IA)                                        
      VOLUME=VOL*CLES*1000.                                                     
      WRITE (6,78) VOLUME                                                       
   78 FORMAT (22H VOLUME OF CRYSTAL IS ,F9.5,6H MM**3)                          
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE IMP                                                            
C                                                                               
      COMMON/REFL/X(3),SCALEN,FSQD,SIGSQ,CHI,CINT,GCOR,NREF,TOTET,OM,PHI        
     $,IDENT,IPLAN,JPLAN                                                        
      COMMON/CN/ICN(32)                                                         
      DIMENSION IX(3)                                                           
      IER=0                                                                     
   12 GO TO (40,14,41) ICN(8)                                                   
C....  ENTREE PAR BANDE ECRITE PAR STEPSCAN OU PSISCAN                          
   14 READ(8,*,   ERR=24,END=28) X,FSQD,SIGSQ,OM,CHI,PHI,TOTET,NREF             
      SCALEN=1.                                                                 
      CALL TEST                                                                 
      IF(IDENT.EQ.100) GO TO 14                                                 
      RETURN                                                                    
C....  ENTREE PAR BANDE ECRITE PAR KARIM OU CARDIN                              
   40 READ(3,ERR=14,END=28)  X,FSQD,SIGSQ                                       
C  40  READ(3,ERR=14,END=28) (IDENT,X,FSQD,SIGSQ)                               
      NREF=NREF+1                                                               
      SCALEN=1.                                                                 
      CALL TEST                                                                 
      IF(IDENT.EQ.100) GO TO 40                                                 
      RETURN                                                                    
C....  ENTREE PAR FICHIER TYPE SHELX                                            
   41 READ(8,*,ERR=28,END=28) IX,FSQD,SIGSQ,IE                                  
      X(1)=IX(1)                                                                
      X(2)=IX(2)                                                                
      X(3)=IX(3)                                                                
      NREF=NREF+1                                                               
      SCALEN=1.                                                                 
      CALL TEST                                                                 
      RETURN                                                                    
   24 WRITE (6,38)                                                              
   38 FORMAT (37H PARITY ERROR-REFLECTION SKIPPED HERE)                         
      IER=IER+1                                                                 
      IF(IER.GE.10) STOP 30                                                     
      GO TO 12                                                                  
   28 IDENT=3                                                                   
      REWIND 3                                                                  
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE INSIDE (XYZ,NOUT,NFACES,DATA)                                  
C                                                                               
C.... CHECKS WHETHER POINT XYZ IS ON SURFACE OF CRYSTAL , SETS NOUT=1 IF        
C                                                                               
      DIMENSION XYZ(3)                                                          
      DIMENSION DATA(25,4)                                                      
      NOUT=0                                                                    
      DO 16 J=1,NFACES                                                          
      CHECK=0.                                                                  
      DO 12 I=1,3                                                               
   12 CHECK=CHECK+DATA(J,I)*XYZ(I)                                              
      TROUBL=DATA(J,4)-CHECK+.0000005                                           
      IF(TROUBL) 14,16,16                                                       
   14 NOUT=1                                                                    
      GO TO 18                                                                  
   16 CONTINUE                                                                  
   18 RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE LENGTH(SD,SOD,TBAR)                                            
C                                                                               
C....  CALCULATES PATH LENGTH OF RAY IN CRYSTAL FOR EACH OF THE SAMPLING        
C....  OF THE GAUSSIAN GRID AND THE ABSORPTION CORRECTION                       
C                                                                               
      REAL*8 SSN(25),GKHKI ,EGKHK                                               
      REAL*8 TAB,TTABS,GKHK                                                     
      REAL*8 ABS,VOLUME  ,VOL                                                   
      REAL*8 GRID(4,4000)                                                       
      REAL*8 RDOTN,RCOS,G,H,GK,HK,AB                                            
      COMMON EPOA,EPOB,GRID                                                     
      COMMON/BORR/SN(25),NMAX,ABSO                                              
      COMMON /A/ RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)        
     $,WI(3,3)                                                                  
      COMMON/C/DATA(25,4)                                                       
      COMMON/D/ELAMDA,COST,SINT,EMU,NPOINT,TETA                                 
      COMMON/E/ABS,VOLUME,NFACES,UM,EXT,FAULT                                   
      COMMON/NEFACH/VOL,CHECK                                                   
      DIMENSION SD(3),SOD(3),COSIN(50),COSOUT(50)                               
      DIMENSION NIN(26), NOUT(26)                                               
      MO=1                                                                      
      LO=1                                                                      
      TTABS=0.                                                                  
      ABS=0.                                                                    
C                                                                               
C....  CALCULATE COSINES OF ANGLES OF INCIDENT AND DIFFRACTED RAYS WITH A       
C                                                                               
      DO 13 I=1,NMAX                                                            
   13 SSN(I)=0.                                                                 
      DO 20 K=1,NFACES                                                          
      COSIN(MO)=0.                                                              
      COSOUT(LO)=0.                                                             
      DO 12 I=1,3                                                               
      COSIN(MO)=COSIN(MO)+SOD(I)*DATA(K,I)                                      
   12 COSOUT(LO)=COSOUT(LO)+SD(I)*DATA(K,I)                                     
C                                                                               
C....  REJECT FACES FOR WHICH ANGLE BETWEEN INCIDENT BEAM AND FACENORMA         
C                                                                               
      IF (COSIN(MO)) 14,16,16                                                   
   14 NIN(MO)=K                                                                 
      MO=MO+1                                                                   
C                                                                               
C....  REJECT FACE IF ANGLE BETWEEN DIFFRACTED RAY AND FACE NORMAL IS O         
C                                                                               
   16 IF (COSOUT(LO)) 20,20,18                                                  
   18 NOUT(LO)=K                                                                
      LO=LO+1                                                                   
   20 CONTINUE                                                                  
      LO=LO-1                                                                   
      MO=MO-1                                                                   
C                                                                               
C....  CALCULATE PATH LENGTH AND ABSORPTION FOR EACH OF THE SAMPLING POIN       
C                                                                               
      DO 34 LL=1,NPOINT                                                         
      GK=1.D37
      HK=1.D37                   
      DO 24 K=1,MO                                                              
      RDOTN=0.                                                                  
      NMO=NIN(K)                                                                
      DO 22 I=1,3                                                               
   22 RDOTN=RDOTN+GRID(I,LL)*DATA(NMO,I)                                        
      RCOS=DATA(NMO,4)-RDOTN                                                    
      G=-RCOS/COSIN(K)                                                          
      GK=DMIN1(GK,G)                                                            
   24 CONTINUE                                                                  
      DO 28 K=1,LO                                                              
      RDOTN=0.                                                                  
      NLO=NOUT(K)                                                               
      DO 26 I=1,3                                                               
   26 RDOTN=RDOTN+GRID(I,LL)*DATA(NLO,I)                                        
      RCOS=DATA(NLO,4)-RDOTN                                                    
      H=RCOS/COSOUT(K)                                                          
      HK=DMIN1(HK,H)                                                            
   28 CONTINUE                                                                  
      GKHK=GK+HK                                                                
C                                                                               
C....  MULTIPLY ABSORPTION FOR EACH GRID POINT BY ITS GAUSSIAN WEIGHT           
C                                                                               
      IF(GKHK.LT.0..OR.GKHK.GT.10.) STOP 123                                    
      EGKHK=EMU*GKHK                                                            
      AB=GRID(4,LL)*DEXP(-EGKHK)                                                
      TAB=GKHK*AB                                                               
      GKHKI=1.                                                                  
      DO 27 I=1,NMAX                                                            
      GKHKI=GKHKI*EGKHK                                                         
   27 SSN(I)=SSN(I) + AB*GKHKI                                                  
C                                                                               
C....  SUM ABSORPTION OVER ALL SAMPLING POINTS                                  
C                                                                               
      TTABS=TTABS+TAB                                                           
      ABS=ABS+AB                                                                
   34 CONTINUE                                                                  
      TBAR=TTABS/ABS                                                            
      ABS=ABS/VOL                                                               
      ABSO=ABS                                                                  
      FACTN=1.                                                                  
      DO 35 I=1,NMAX                                                            
      FACTN=FACTN*I                                                             
   35 SN(I)=SSN(I)/(FACTN*VOL)                                                  
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE MAM (A,B,C)                                                    
C                                                                               
C....  MULTIPLIES MATRIX-A-BY MATRIX-B-                                         
C....  A(3,3)*B(3,3)=C(3,3)                                                     
C                                                                               
      DIMENSION A(3,3), B(3,3), C(3,3)                                          
      DO 12 I=1,3                                                               
      DO 12 K=1,3                                                               
      C(I,K)=0.0                                                                
      DO 12 J=1,3                                                               
   12 C(I,K)=C(I,K)+A(I,J)*B(J,K)                                               
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE MINMAX (A,LA,PMIN,PMAX)                                        
C                                                                               
      REAL*8 A(50),PMIN,PMAX                                                    
      PMIN=A(1)                                                                 
      PMAX=A(1)                                                                 
      DO 12 I=2,LA                                                              
      PMIN=DMIN1(PMIN,A(I))                                                     
   12 PMAX=DMAX1(PMAX,A(I))                                                     
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE MULREF                                                         
C                                                                               
      COMMON/ST/THICK,SIG1,SIG2,N  ,TH(3,2000)                                  
      DIMENSION FH(3,100)                                                       
C....  THICK EST L EPAISSEUR DE LA SPHERE D EWALD                               
      READ (5,*)THICK                                                           
 1000 FORMAT(3F10.5)                                                            
      WRITE(6,1002)THICK                                                        
 1002 FORMAT(///,' EPAISSEUR DE LA SPHERE DE REFLECTION = ',F10.6,' A-1'        
     $,////)                                                                    
C....  INDICATEURS DE SYMETRIE                                                  
      READ (5,*)IH,IK,IL,IHK,IKL,IHL,IKLH,ILHK                                  
 1001 FORMAT(16I5)                                                              
      ISR=1                                                                     
C....  ENTREE DU TABLEAU DES REFLECTIONS FORTES                                 
  100 READ (5,*)IDENT,(FH(I,ISR),I=1,3)                                         
 1003 FORMAT(I5,3F5.0 )                                                         
      IF(IDENT)102,101,102                                                      
  101 ISR=ISR+1                                                                 
      GO TO 100                                                                 
  102 ISR=ISR-1                                                                 
C....  EXPANSION DES REFLECTIONS FORTES PAR SYMETRIE                            
      WRITE(6,1004)                                                             
 1004 FORMAT(///,' LISTE DES RAIES FORTES  SUSCEPTIBLES DE DONNER DES MU        
     $LTIPLES REFLECTIONS ',//)                                                 
      N=0                                                                       
      DO 200 I=1,ISR                                                            
      N=N+1                                                                     
      DO 201 J=1,3                                                              
  201 TH(J,N)=FH(J,I)                                                           
      N=N+1                                                                     
      DO 202 J=1,3                                                              
  202 TH(J,N)=-FH(J,I)                                                          
      IF(IH.EQ.0.OR.FH(1,I).EQ.0..OR.FH(2,I).EQ.0..AND.FH(3,I).EQ.0.)           
     $GO TO 205                                                                 
      N=N+1                                                                     
      TH(1,N)=-FH(1,I)                                                          
      TH(2,N)=FH(2,I)                                                           
      TH(3,N)=FH(3,I)                                                           
      N=N+1                                                                     
      DO 204 J=1,3                                                              
  204 TH(J,N)=-TH(J,N-1)                                                        
  205 IF(IK.EQ.0.OR.FH(2,I).EQ.0..OR.FH(1,I).EQ.0..AND.FH(3,I).EQ.0.)           
     $GO TO 208                                                                 
      N=N+1                                                                     
      TH(1,N)=FH(1,I)                                                           
      TH(2,N)=-FH(2,I)                                                          
      TH(3,N)=FH(3,I)                                                           
      N=N+1                                                                     
      DO 207 J=1,3                                                              
  207 TH(J,N)=-TH(J,N-1)                                                        
  208 IF(IL.EQ.0.OR.FH(3,I).EQ.0..OR.FH(1,I).EQ.0..AND.FH(2,I).EQ.0.)           
     $GO TO 200                                                                 
      N=N+1                                                                     
      TH(1,N)=FH(1,I)                                                           
      TH(2,N)=FH(2,I)                                                           
      TH(3,N)=-FH(3,I)                                                          
      N=N+1                                                                     
      DO 210 J=1,3                                                              
  210 TH(J,N)=-TH(J,N-1)                                                        
  200 CONTINUE                                                                  
      NN=N                                                                      
      DO 311 NROM=1,N                                                           
      IF(IHK.EQ.0.OR.TH(1,NROM).EQ.TH(2,NROM)) GO TO 302                        
      NN=NN+1                                                                   
      TH(1,NN)=TH(2,NROM)                                                       
      TH(2,NN)=TH(1,NROM)                                                       
      TH(3,NN)=TH(3,NROM)                                                       
  302 IF(IKL.EQ.0.OR.TH(2,NROM).EQ.TH(3,NROM)) GO TO 304                        
      NN=NN+1                                                                   
      TH(1,NN)=TH(1,NROM)                                                       
      TH(2,NN)=TH(3,NROM)                                                       
      TH(3,NN)=TH(2,NROM)                                                       
  304 IF(IHL.EQ.0.OR.TH(1,NROM).EQ.TH(3,NROM)) GO TO 306                        
      NN=NN+1                                                                   
      TH(1,NN)=TH(3,NROM)                                                       
      TH(2,NN)=TH(2,NROM)                                                       
      TH(3,NN)=TH(1,NROM)                                                       
  306 IF(TH(1,NROM).EQ.TH(2,NROM).OR.TH(1,NROM).EQ.TH(3,NROM).OR.TH(2,NR        
     $OM).EQ.TH(3,NROM)) GO TO 311                                              
      NN=NN+1                                                                   
      TH(1,NN)=TH(3,NROM)                                                       
      TH(2,NN)=TH(1,NROM)                                                       
      TH(3,NN)=TH(2,NROM)                                                       
  311 CONTINUE                                                                  
      N=NN                                                                      
      WRITE(6,1005)(J,(TH(I,J),I=1,3),J=1,N)                                    
 1005 FORMAT(1H ,3(I4,3F7.0,' *   '))                                           
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE MV (X,Y,Z)                                                     
C                                                                               
C.... SUBROUTINE MV MULTIPLIES VECTOR Y WITH MATRIX X. Z(I)=X(I,J)*Y(J)         
C                                                                               
      DIMENSION X(3,3), Y(3), Z(3)                                              
      DO 12 I=1,3                                                               
      Z(I)=0.                                                                   
      DO 12 J=1,3                                                               
   12 Z(I)=Z(I)+X(I,J)*Y(J)                                                     
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE NORM (A)                                                       
C                                                                               
      DO 14 I=1,10                                                              
      IF (A) 12,16,16                                                           
   12 A=A+360.                                                                  
   14 CONTINUE                                                                  
   16 A=AMOD(A,360.)                                                            
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE NORMAL (SD,SOD,XN)                                             
C                                                                               
C.... SUBROUTINE CALCULATES COMPONENTS OF NORMAL TO DIFFRACTION PLANE           
C.... ALONG A,B,C.                                                              
C                                                                               
      COMMON /A/ RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)        
     $,DST(3,3)                                                                 
      DIMENSION DRCS(3)                                                         
      DIMENSION SD(3), SOD(3), XN(3), YN(3)                                     
      DATA IS/0/                                                                
      IF (IS.NE.0) GO TO 14                                                     
      DO 12 I=1,3                                                               
   12 DRCS(I)=SQRT(1.-DRC(I+3)**2)                                              
      IS=1                                                                      
   14 I=1                                                                       
      J=2                                                                       
   16 K=6-I-J                                                                   
C                                                                               
C....  YN ARE COMPONENTS OF NORMAL ALONG RECIPROCAL AXES                        
C                                                                               
      YN(K)=(SD(I)*SOD(J)-SD(J)*SOD(I))*DRC(I)*DRC(J)*DRCS(K)/RCP(K)            
      IF (I.EQ.1) GO TO 18                                                      
      IF (I.EQ.3) GO TO 20                                                      
      IF (I.EQ.2) GO TO 22                                                      
   18 I=3                                                                       
      J=1                                                                       
      GO TO 16                                                                  
   20 I=2                                                                       
      J=3                                                                       
      GO TO 16                                                                  
   22 DO 24 I=1,3                                                               
C                                                                               
C....  XN ARE COMPONENTS OF NORMAL ALONG DIRECT AXES                            
C                                                                               
      XN(I)=0.                                                                  
      DO 24 J=1,3                                                               
   24 XN(I)=XN(I)+RECIP(I,J)*YN(J)                                              
      FNORM=0.                                                                  
      DO 26 I=1,3                                                               
   26 FNORM=FNORM+XN(I)*YN(I)                                                   
      FNORM=SQRT(FNORM)                                                         
      DO 28 I=1,3                                                               
C                                                                               
C....  CONVERT TO COMPONENTS ALONG UNIT AXIS AND NORMALIZE                      
C                                                                               
   28 XN(I)=XN(I)/FNORM*DRC(I)                                                  
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE RENING(SO,S,MULT,XREN,NREN)                                    
C                                                                               
      COMMON/A/RCP(6),RECIP(3,3),DIRECT(3,3),DRC(6),SHUFEL(3,3),W(3,3)          
     $,WI(3,3)                                                                  
      COMMON/D/ELAMDA,COST,SINT,EMU,NPOINT,TETA                                 
      COMMON/REFL/X(3),SCALEN,F,SIGF,CHI,CINT,GCOR,NREF,TOTET,OM,PHI,           
     $IDENT,IPLAN,JPLAN                                                         
      COMMON/ST/THICK,SIG1,SIG2,NST,TH(3,2000)                                  
      DIMENSION SO(3),S(3),XREN(3),CH1(3),CH2(3)                                
      MULT=0                                                                    
      DO 1 I=1,3                                                                
    1 XREN(I)=0.                                                                
      DO 2 K=1,NST                                                              
C....  SKIP CHECK IF STRONG REFLECTION IS REFLECTION TO BE RECORDED             
      IF(TH(1,K).EQ.X(1) .AND.TH(2,K).EQ.X(2) .AND.TH(3,K).EQ.X(3)              
     $) GO TO 2                                                                 
      IF(TH(1,K).EQ.-X(1) .AND.TH(2,K).EQ.-X(2) .AND.TH(3,K).EQ.-X(3            
     $)) GO TO 2                                                                
      IF(TH(1,K).EQ.0..AND.TH(2,K).EQ.0..AND.TH(3,K).EQ.0.) GO TO 2             
      DO 3 I=1,3                                                                
      CH1(I)=SO(I)+ELAMDA*TH(I,K)                                               
    3 CH2(I)=S(I)+ELAMDA*TH(I,K)                                                
      CH1L=0.                                                                   
      CH2L=0.                                                                   
      DO 4 I=1,3                                                                
      DO 4 J=1,3                                                                
      CH1L=CH1L+CH1(I)*RECIP(I,J)*CH1(J)                                        
    4 CH2L=CH2L+CH2(I)*RECIP(I,J)*CH2(J)                                        
      CH1L=SQRT(CH1L)                                                           
      CH2L=SQRT(CH2L)                                                           
      TES1=ABS(CH1L-1.)                                                         
      FAIL=TES1-THICK                                                           
      IF(FAIL.LE.0.) MULT=1                                                     
      TES2=ABS(CH2L-1.)                                                         
      FAIL=TES2-THICK                                                           
      IF(FAIL.LE.0.) MULT=MULT+2                                                
      IF(MULT.NE.0) GO TO 6                                                     
    2 CONTINUE                                                                  
      GO TO 8                                                                   
    6 DO 12 I=1,3                                                               
   12 XREN(I)=TH(I,K)                                                           
      NREN=NREN+1                                                               
    8 RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE SPHERE(TBAR)                                                   
C                                                                               
C.... ABSORPTION SPHERIQUE                                                      
C                                                                               
      REAL*8 ABS,VOL                                                            
      COMMON/D/ELAMDA,COST,SINT,EMU,NPOINT,TETA                                 
      COMMON/E/ABS,VOL,NFACES,UM,EXT,FAULT                                      
      COMMON/BORR/SN(25),NMAX,ABSO                                              
      DIMENSION AS(100),AS1(100),AS2(100),TB(100),TB1(100),TB2(100)             
      DIMENSION TABL(100,25)                                                    
      DATA IS/0/                                                                
      IF(IS.NE.0) GO TO 10                                                      
      READ (5,100)XMUR,STEP,NV                                                  
  100 FORMAT(2F10.5,I5)                                                         
      IF(XMUR.GT.0.0001) GO TO 5                                                
      READ (5,101)XMUR,(AS(I),I=1,NV)                                           
      READ (5,101)XMUR,(TB(I),I=1,NV)                                           
      IF(NMAX.EQ.0) GO TO 9                                                     
      DO 52 J=1,NMAX                                                            
   52 READ (5,105)XMUR,(TABL(I,J),I=1,NV)                                       
  105 FORMAT(8E10.4)                                                            
      WRITE(6,106)((TABL(I,J),I=1,NV),J=1,NMAX)                                 
  106 FORMAT(' TABLES POUR L EFFET BORRMANN : ',/,250(10E12.4,/))               
      GO TO 9                                                                   
    5 READ (5,101)XMUR1,(AS1(I),I=1,NV)                                         
      READ (5,101)XMUR2,(AS2(I),I=1,NV)                                         
      READ (5,101)XMUR1,(TB1(I),I=1,NV)                                         
      READ (5,101)XMUR2,(TB2(I),I=1,NV)                                         
  101 FORMAT(8F10.5)                                                            
      X=XMUR2-XMUR1                                                             
      X1=(XMUR2-XMUR)/X                                                         
      X2=1.-X1                                                                  
      DO 1 I=1,NV                                                               
      AS(I)=X1*AS1(I)+X2*AS2(I)                                                 
    1 TB(I)=X1*TB1(I)+X2*TB2(I)                                                 
    9 IS=1                                                                      
      WRITE (6,102)XMUR ,STEP                                                   
  102 FORMAT(//,' TABLES POUR L ABSORPTION SPHERIQUE MUR = ',F10.5,'            
     $PAS EN THETA = ',F10.2,/)                                                 
      WRITE (6,103)(AS(I),I=1,NV)                                               
  103 FORMAT(' TABLE DE A*',/,10(10F12.5,/))                                    
      WRITE(6,104)(TB(I),I=1,NV)                                                
  104 FORMAT(' TABLE DE TBAR *MU',/,10(10F12.5,/))                              
   10 T=TETA/STEP+1.                                                            
      IT=T                                                                      
      IT1=IT+1                                                                  
      FRAC=T-FLOAT(IT)                                                          
      ASTAR=AS(IT) + (AS(IT1 )-AS(IT))*FRAC                                     
      TBAR=TB(IT) + (TB(IT1 )-TB(IT))*FRAC                                      
      ABS=1./ASTAR                                                              
      TBAR=TBAR/EMU                                                             
      ABSO=ABS                                                                  
      DO 20 I=1,NMAX                                                            
   20 SN(I)=TABL(IT,I)+(TABL(IT1,I)-TABL(IT,I) )*FRAC                           
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE TEST                                                           
C                                                                               
      COMMON/REFL/X(3),SCALEN,FSQD,SIGSQ,CHI,CINT,GCOR,NREF,TOTET,OM,PHI        
     $,IDENT,IPLAN,JPLAN                                                        
      IDENT=0                                                                   
      IF(FSQD.LE.0.) IDENT=100                                                  
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE UMATRI                                                         
C                                                                               
C....  ADAPTEE A UN DIFFRACTOMETRE PHILIPS PW 1100 MATRICE UB                   
C....  OMEGA = THETA - OMEGA ( PW 1100 )                                        
      COMMON /A/ REC(6),GREC(3,3),G(3,3),CELL(6),SHUFEL(3,3),UTRA(3,3)          
     $,WI(3,3)                                                                  
      COMMON/D/FLAM,COST,SINT,EMU,NPOINT,TETA                                   
      COMMON/CN/ICN(32)                                                         
      DIMENSION H(3,3), CHI(3), OM(3), PHI(3), TWOTH(3), UP(3,3), DSTAR(        
     $3), HH(3,3), TH(3), U(3,3),UB(3,3)                                        
      ORAD=ACOS(-1.)/180.                                                       
      READ (5,*)FLAM                                                            
   24 FORMAT(2F10.4)                                                            
      WRITE (6,28)FLAM                                                          
   28 FORMAT(' WAVELENGTH =',F10.6)                                             
      IF(ICN(13).NE.0)GO TO 100                                                 
      READ (5,*) ((H(I,J),J=1,3),TWOTH(I),OM(I),CHI(I),PHI(I),I=1,3)            
   22 FORMAT (3F10.0,4F10.4)                                                    
      WRITE (6,26)  ((H(I,J),J=1,3),TWOTH(I),OM(I),CHI(I),PHI(I),I=1,3)         
   26 FORMAT(' THREE REFERENCE REFLECTIONS(FROM CELREFA(CHI ZERO NE 0) O        
     $R FROM FACS-1(CHI ZERO =0))',/,3X,'H',3X,'K',3X,'L',4X,'TWO THETA'        
     $,5X,'OMEGA',8X,'CHI',8X,'PHI'/3(1X,3F4.0,4F11.6/))                        
      ZRAD=0.5*ORAD                                                             
      DO 12 I=1,3                                                               
      PHI(I)=PHI(I)*ORAD                                                        
      CHI(I)=CHI(I)*ORAD                                                        
      OM(I)=OM(I)*ORAD                                                          
      TH(I)=TWOTH(I)*ZRAD                                                       
   12 OM(I)=TH(I)-OM(I)                                                         
      DO 14 I=1,3                                                               
      DSTAR(I)=(2.*SIN(TH(I)))/FLAM                                             
      UP(I,1)=(-COS(PHI(I))*SIN(OM(I))+SIN(PHI(I))*COS(CHI(I))*COS(OM(          
     $I)))*DSTAR(I)                                                             
      UP(I,2)=(+SIN(PHI(I))*SIN(OM(I))+COS(PHI(I))*COS(CHI(I))*COS(OM(          
     $I)))*DSTAR(I)                                                             
      UP(I,3)=(-SIN(CHI(I))*COS(OM(I)))*DSTAR(I)                                
      TH(I)=TH(I)/ORAD                                                          
      WRITE (6,30) I,DSTAR(I),TH(I)                                             
   30 FORMAT (7H0ANGLE(,I1,14H)     DSTAR = ,F10.6,23H         THETA (OB        
     $S) = ,F10.4)                                                              
   14 WRITE (6,32) (UP(I,J),J=1,3)                                              
   32 FORMAT (1H ,12X,9H(UP(1) = ,F10.6,1H)/1H ,12X,9H(UP(2) = ,F10.6,1H        
     $)/1H ,12X,9H(UP(3) = ,F10.6,1H)/)                                         
      CALL AMI3 (H,HH,DET)                                                      
      WRITE (6,34) ((HH(I,J),J=1,3),I=1,3)                                      
   34 FORMAT (37H0HH MATRIX (INVERSE OF H TRIPLES) IS /3(3X,3F10.6/))           
      CALL MAM (HH,UP,U)                                                        
      GO TO 102                                                                 
  100 READ (5,*) ((UB(I,J),J=1,3),I=1,3)                                        
  110 FORMAT(3F10.6)                                                            
      WRITE (6,220)((UB(J,I),I=1,3),J=1,3)                                      
  220 FORMAT(/34H UB MATRIX PHILIPS READ FROM CARDS/3(3F10.6/))                 
      DO 10 I=1,3                                                               
      DO 10 J=1,3                                                               
   10 U(I,J)=UB(J,I)/FLAM                                                       
  102 DO 16 I=1,3                                                               
      DO 16 J=1,3                                                               
   16 UTRA(I,J)=U(J,I)                                                          
      CALL MAM (U,UTRA,GREC)                                                    
      WRITE (6,36) GREC                                                         
   36 FORMAT(23H  THE RECIPROCAL METRIC/(3F12.6))                               
      CALL AMI3 (GREC,G,DET)                                                    
      WRITE (6,38) G                                                            
   38 FORMAT (/19H  THE DIRECT METRIC/(3F12.6))                                 
      DO 18 I=1,3                                                               
      REC(I)=SQRT(GREC(I,I))                                                    
   18 CELL(I)=SQRT(G(I,I))                                                      
      REC(4)=GREC(2,3)/(REC(2)*REC(3))                                          
      REC(5)=GREC(1,3)/(REC(1)*REC(3))                                          
      REC(6)=GREC(1,2)/(REC(1)*REC(2))                                          
      CELL(4)=G(2,3)/(CELL(2)*CELL(3))                                          
      CELL(5)=G(1,3)/(CELL(1)*CELL(3))                                          
      CELL(6)=G(1,2)/(CELL(1)*CELL(2))                                          
      WRITE (6,42)                                                              
   42 FORMAT (23H0DIRECT CELL PARAMETERS/1H ,15X,1HA,14X,1HB,14X,1HC,16X        
     $,8HCOSALPHA,7X,7HCOSBETA,8X,8HCOSGAMMA)                                   
      WRITE (6,40) (CELL(I),I=1,3),(CELL(I),I=4,6)                              
   40 FORMAT (10X,F10.6,2F15.6,4X,3F15.6)                                       
      WRITE (6,44)                                                              
   44 FORMAT (27H0RECIPROCAL CELL PARAMETERS/1H ,15X,1HA,14X,1HB,14X,1HC        
     $,16X,8HCOSALPHA,7X,7HCOSBETA,8X,8HCOSGAMMA)                               
      WRITE (6,40) (REC(I),I=1,3),(REC(I),I=4,6)                                
      DO 20 K=1,3                                                               
      DO 20 L=1,3                                                               
   20 SHUFEL(K,L)=UTRA(K,L)/REC(L)                                              
      RETURN                                                                    
      END                                                                       
C***********************************************************************        
C                                                                               
      SUBROUTINE VM (X,Y,Z)                                                     
C                                                                               
C.... MULTIPLIES VECTOR WITH MATRIX. X(3)*Y(3,3)=Z(3)                           
C                                                                               
      DIMENSION X(3), Y(3,3), Z(3)                                              
      DO 12 I=1,3                                                               
      Z(I)=0.                                                                   
      DO 12 J=1,3                                                               
   12 Z(I)=Z(I)+X(J)*Y(J,I)                                                     
      RETURN                                                                    
      END                                                                       
